if(MSVC)
    set(inline __inline)
endif(MSVC)
set(HAVE_THREADS 1)
set(WITH_OUR_MALLOC16 1)
set(STDC_HEADERS 1)
set(HAVE_UINTPTR_T 1)
set(HAVE_UINTPTR_T 1)
set(HAVE_SIMD 1)
set(HAVE_LONG_DOUBLE 1)
set(HAVE_OPENMP ${ENABLE_OPENMP})

set(HAVE_SSE 1)
if(FFTW_DOUBLE)
    set(HAVE_SSE2 1) # only works in double precision
endif(FFTW_DOUBLE)

if(FFTW_SINGLE)
    set(FFTW_SYMBOL_PREFIX "fftwf_")
elseif(FFTW_DOUBLE)
    set(FFTW_SYMBOL_PREFIX "fftw_")
elseif(FFTW_LDOUBLE)
    set(FFTW_SYMBOL_PREFIX "fftwl_")
endif(FFTW_SINGLE)

if(BUILD_BENCHMARKS)
    set(BENCHFFT_SINGLE ${FFTW_SINGLE})
    set(BENCHFFT_DOUBLE ${FFTW_DOUBLE})
    set(BENCHFFT_LDOUBLE ${FFTW_LDOUBLE})
endif(BUILD_BENCHMARKS)
#/* extra CFLAGS for codelets */
#cmakedefine CODELET_OPTIM @CODELET_OPTIM@

include(CheckIncludeFiles)
include(CheckSymbolExists)
include(CheckTypeSize)

check_include_files(alloca.h HAVE_ALLOCA_H)
check_include_files(stdlib.h HAVE_STDLIB_H)
check_include_files(stdint.h HAVE_STDINT_H)
check_include_files(stddef.h HAVE_STDDEF_H)
check_include_files(altivec.h HAVE_ALTIVEC_H)
check_include_files(c_asm.h HAVE_C_ASM_H)
check_include_files(dlfcn.h HAVE_DLFCN_H)
check_include_files(intrinsics.h HAVE_INTRINSICS_H)
check_include_files(inttypes.h HAVE_INTTYPES_H)
check_include_files(libintl.h HAVE_LIBINTL_H)
check_include_files(limits.h HAVE_LIMITS_H)
check_include_files(mach/mach_time.h HAVE_MACH_MACH_TIME_H)
check_include_files(malloc.h HAVE_MALLOC_H)
check_include_files(memory.h HAVE_MEMORY_H)
check_include_files(stddef.h HAVE_STDDEF_H)
check_include_files(stdint.h HAVE_STDINT_H)
check_include_files(stdlib.h HAVE_STDLIB_H)
check_include_files(strings.h HAVE_STRINGS_H)
check_include_files(string.h HAVE_STRING_H)
check_include_files(sys/stat.h HAVE_SYS_STAT_H)
check_include_files(sys/sysctl.h HAVE_SYS_SYSCTL_H)
check_include_files(sys/time.h HAVE_SYS_TIME_H)
check_include_files(sys/types.h HAVE_SYS_TYPES_H)
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(xmmintrin.h HAVE_XMMINTRIN_H)

check_type_size("double" SIZEOF_DOUBLE)
check_type_size("float" SIZEOF_FLOAT)
check_type_size("int" SIZEOF_INT)
check_type_size("long" SIZEOF_LONG)
check_type_size("long long" SIZEOF_LONG_LONG)
check_type_size("ptrdiff_t" SIZEOF_PTRDIFF_T)
check_type_size("size_t" SIZEOF_SIZE_T)
check_type_size("unsigned int" SIZEOF_UNSIGNED_INT)
check_type_size("unsigned long" SIZEOF_UNSIGNED_LONG)
check_type_size("unsigned long long" SIZEOF_UNSIGNED_LONG_LONG)
check_type_size("void*" SIZEOF_VOID_P)

######################################################################################

#/* Define to enable extra FFTW debugging code. */
#cmakedefine FFTW_DEBUG

#/* Define to enable alignment debugging hacks. */
#cmakedefine FFTW_DEBUG_ALIGNMENT

#/* Define to enable debugging malloc. */
#cmakedefine FFTW_DEBUG_MALLOC


#/* Define to 1 if using `alloca.c'. */
#cmakedefine C_ALLOCA

#/* Define to enable the use of alloca(). */
#cmakedefine FFTW_ENABLE_ALLOCA

#/* Define to 1 if you have `alloca', as a function or macro. */
#cmakedefine HAVE_ALLOCA

#/* Define to 1 if you have the `abort' function. */
#cmakedefine HAVE_ABORT

#/* Define to enable Altivec optimizations. */
#cmakedefine HAVE_ALTIVEC

#/* Define to 1 if you have the `BSDgettimeofday' function. */
#cmakedefine HAVE_BSDGETTIMEOFDAY

#/* Define to enable optimizations for the Cell Broadband Engine */
#cmakedefine HAVE_CELL

#/* Define to 1 if you have the `clock_gettime' function. */
#cmakedefine HAVE_CLOCK_GETTIME

#/* Define to 1 if you have the `cosl' function. */
#cmakedefine HAVE_COSL

#/* Define to 1 if you have the declaration of `cosl', and to 0 if you don't.
#   */
#cmakedefine HAVE_DECL_COSL

#/* Define to 1 if you have the declaration of `drand48', and to 0 if you
#   don't. */
#cmakedefine HAVE_DECL_DRAND48

#/* Define to 1 if you have the declaration of `memalign', and to 0 if you
#   don't. */
#cmakedefine HAVE_DECL_MEMALIGN

#/* Define to 1 if you have the declaration of `posix_memalign', and to 0 if
#   you don't. */
#cmakedefine HAVE_DECL_POSIX_MEMALIGN

#/* Define to 1 if you have the declaration of `sinl', and to 0 if you don't.
#   */
#cmakedefine HAVE_DECL_SINL

#/* Define to 1 if you don't have `vprintf' but do have `_doprnt.' */
#cmakedefine HAVE_DOPRNT

#/* Define to 1 if you have the `drand48' function. */
#cmakedefine HAVE_DRAND48

#/* Define if you have a machine with fused multiply-add */
#cmakedefine HAVE_FMA

#/* Define to 1 if you have the `gethrtime' function. */
#cmakedefine HAVE_GETHRTIME

#/* Define to 1 if you have the `gettimeofday' function. */
#cmakedefine HAVE_GETTIMEOFDAY

#/* Define to 1 if hrtime_t is defined in <sys/time.h> */
#cmakedefine HAVE_HRTIME_T

#/* Define if the isnan() function/macro is available. */
#cmakedefine HAVE_ISNAN

#/* Define to 1 if you have the `m' library (-lm). */
#cmakedefine HAVE_LIBM

#/* Define to 1 if you have the `spe' library (-lspe). */
#cmakedefine HAVE_LIBSPE

#/* Define to 1 if you have the `spe2' library (-lspe2). */
#cmakedefine HAVE_LIBSPE2

#/* Define to 1 if you have the `mach_absolute_time' function. */
#cmakedefine HAVE_MACH_ABSOLUTE_TIME

#/* Define to 1 if you have the `memalign' function. */
#cmakedefine HAVE_MEMALIGN

#/* Define to 1 if you have the `memset' function. */
#cmakedefine HAVE_MEMSET

#/* Define to enable MIPS paired-single optimizations. */
#cmakedefine HAVE_MIPS_PS

#/* Define to enable use of MIPS ZBus cycle-counter. */
#cmakedefine HAVE_MIPS_ZBUS_TIMER

#/* Define if you have the MPI library. */
#cmakedefine HAVE_MPI

#/* Define if we have and are using OpenMP multithreading directives */
#cmakedefine USING_OPENMP_THREADS

#/* Define to 1 if you have the `posix_memalign' function. */
#cmakedefine HAVE_POSIX_MEMALIGN

#/* Define if you have POSIX threads libraries and header files. */
#cmakedefine HAVE_PTHREAD

#/* Define to 1 if you have the `read_real_time' function. */
#cmakedefine HAVE_READ_REAL_TIME

#/* Define to 1 if you have the `sinl' function. */
#cmakedefine HAVE_SINL

#/* Define to 1 if you have the `snprintf' function. */
#cmakedefine HAVE_SNPRINTF

#/* Define to 1 if you have the `sqrt' function. */
#cmakedefine HAVE_SQRT

#/* Define to enable SSE optimizations. */
#cmakedefine HAVE_SSE @HAVE_SSE@

#/* Define to enable SSE2 optimizations. */
#cmakedefine HAVE_SSE2 @HAVE_SSE2@

#/* Define to 1 if you have the `sysctl' function. */
#cmakedefine HAVE_SYSCTL

#/* Define to 1 if you have the `tanl' function. */
#cmakedefine HAVE_TANL

#/* Define if we have a threads library. */
#cmakedefine HAVE_THREADS

#/* Define to 1 if you have the `time_base_to_time' function. */
#cmakedefine HAVE_TIME_BASE_TO_TIME

#/* Define to 1 if the system has the type `uintptr_t'. */
#cmakedefine HAVE_UINTPTR_T

#/* Define to 1 if you have the `vprintf' function. */
#cmakedefine HAVE_VPRINTF

#/* Define to 1 if you have the `_mm_free' function. */
#cmakedefine HAVE__MM_FREE

#/* Define to 1 if you have the `_mm_malloc' function. */
#cmakedefine HAVE__MM_MALLOC

#/* Define if you have the UNICOS _rtc() intrinsic. */
#cmakedefine HAVE__RTC

#/* Define to necessary symbol if this constant uses a non-standard name on
#   your system. */
#cmakedefine PTHREAD_CREATE_JOINABLE

#/* If using the C implementation of alloca, define if you know the
#   direction of stack growth for your system; otherwise it will be
#   automatically deduced at runtime.
#	STACK_DIRECTION > 0 => grows toward higher addresses
#	STACK_DIRECTION < 0 => grows toward lower addresses
#	STACK_DIRECTION = 0 => direction of growth unknown */
#cmakedefine STACK_DIRECTION

#/* Define to 1 if you can safely include both <sys/time.h> and <time.h>. */
#cmakedefine TIME_WITH_SYS_TIME

##########################################################################
# stuff I don't know what to do with:
#/* Use low-precision timers, making planner very slow */
#cmakedefine WITH_SLOW_TIMER
#/* Define if we have and are using POSIX threads. */
#cmakedefine USING_POSIX_THREADS

# Fortran stuff: not implemented
#cmakedefine DISABLE_FORTRAN
#cmakedefine F77_DUMMY_MAIN
#cmakedefine F77_FUNC
#cmakedefine F77_FUNC_
#cmakedefine F77_FUNC_EQUIV
#cmakedefine FC_DUMMY_MAIN_EQ_F77
#cmakedefine WINDOWS_F77_MANGLING
#cmakedefine WITH_G77_WRAPPERS



configure_file(config.h.cmake config.h)
configure_file(fftw.def.cmake fftw.def)
