# generate file codlist.c

macro(write_codelet_list CODLIST CODELET_NAME SOLVTAB_NAME)
    file(RELATIVE_PATH filename ${CMAKE_BINARY_DIR} ${CODLIST})
    message(STATUS "writing codelet list file ${filename}")
    file(WRITE ${CODLIST} "#include \"ifftw.h\"\n\n")
    foreach(codelet ${ARGN})
        string(REGEX REPLACE "([A-Za-z0-9_]*)\\.c" "\\1" codeletbase "${codelet}")
        file(APPEND ${CODLIST} "extern void X(${CODELET_NAME}${codeletbase})(planner *);\n")
    endforeach(codelet ${ARGN})
    file(APPEND ${CODLIST} "\n\nextern const solvtab ${SOLVTAB_NAME};\n")
    file(APPEND ${CODLIST} "const solvtab ${SOLVTAB_NAME} = {\n")
    foreach(codelet ${ARGN})
        string(REGEX REPLACE "([A-Za-z0-9_]*)\\.c" "\\1" codeletbase "${codelet}")
        file(APPEND ${CODLIST} "    SOLVTAB(X(${CODELET_NAME}${codeletbase})),\n")
    endforeach(codelet ${ARGN})
    file(APPEND ${CODLIST} "    SOLVTAB_END\n};\n")
endmacro(write_codelet_list CODLIST CODELET_NAME SOLVTAB_NAME)